'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _knex = require('knex');

var _knex2 = _interopRequireDefault(_knex);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var VERSION_SEPERATOR = '@';

/**
 * PostgresqlAdapter
 *
 * @class PostgresqlAdapter
 *
 * @param {Object} config The postgresql connection configuration
 */

var PostgresqlAdapter = function () {
  function PostgresqlAdapter(config) {
    _classCallCheck(this, PostgresqlAdapter);

    this.config = config;
    this.connections = {};
  }

  /**
   * Get a postgresql connection.
   *
   * @param  {String} projectName
   * @param  {Number} projectVersion
   *
   * @return {Object} The knex.js connection
   */

  _createClass(PostgresqlAdapter, [{
    key: 'getConnection',
    value: function getConnection(projectName, projectVersion) {
      if (!this.connections[projectName + VERSION_SEPERATOR + projectVersion]) {
        var options = {
          client: 'postgresql',
          connection: {
            host: this.config.host,
            user: this.config.user,
            password: this.config.password,
            database: projectName + (projectVersion ? VERSION_SEPERATOR + projectVersion : '')
          },
          pool: {
            min: 0,
            max: 1
          }
        };
        this.connections[projectName + VERSION_SEPERATOR + projectVersion] = (0, _knex2.default)(options);
      }
      return this.connections[projectName + VERSION_SEPERATOR + projectVersion];
    }
  }]);

  return PostgresqlAdapter;
}();

exports.default = PostgresqlAdapter;