'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _pg = require('pg');

var _pg2 = _interopRequireDefault(_pg);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

_bluebird2.default.promisifyAll(_pg2.default);

var VERSION_SEPERATOR = '@';

/**
 * PostgresqlDropper
 *
 * @class PostgresqlDropper
 */

var PostgresqlDropper = function () {
  function PostgresqlDropper(config) {
    _classCallCheck(this, PostgresqlDropper);

    this.config = config;
  }

  /**
   * Drop the postgresql database.
   *
   * @param  {String} projectName
   * @param  {Number} projectVersion
   *
   * @return {Promise}
   */

  _createClass(PostgresqlDropper, [{
    key: 'drop',
    value: function drop(projectName, projectVersion) {
      var connectionString, client, database, dropConnectionsResult, dropDbResult;
      return regeneratorRuntime.async(function drop$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            connectionString = 'postgresql://' + this.config.user + ':' + this.config.password + '@' + this.config.host + '/postgres';
            _context.next = 3;
            return regeneratorRuntime.awrap(this.getConnection(connectionString));

          case 3:
            client = _context.sent;
            database = projectName + VERSION_SEPERATOR + String(projectVersion);
            _context.next = 7;
            return regeneratorRuntime.awrap(client.queryAsync('SELECT pg_terminate_backend(pid) FROM pg_stat_activity WHERE datname = \'' + database + '\''));

          case 7:
            dropConnectionsResult = _context.sent;
            _context.prev = 8;
            _context.next = 11;
            return regeneratorRuntime.awrap(client.queryAsync('DROP DATABASE "' + database + '"'));

          case 11:
            dropDbResult = _context.sent;
            _context.next = 17;
            break;

          case 14:
            _context.prev = 14;
            _context.t0 = _context['catch'](8);

            console.error('If the error says the db didn\'t exist, ignore this', _context.t0);

          case 17:
            this.connectionCloser();

          case 18:
          case 'end':
            return _context.stop();
        }
      }, null, this, [[8, 14]]);
    }

    /**
     * Get the connection to the postgres database
     * @protected
     * @param  {String} connectionString
     * @return {Object} The postgresql client
     */

  }, {
    key: 'getConnection',
    value: function getConnection(connectionString) {
      var _this = this;

      return _pg2.default.connectAsync(connectionString).spread(function (client, done) {
        _this.connectionCloser = done;
        return client;
      });
    }
  }]);

  return PostgresqlDropper;
}();

exports.default = PostgresqlDropper;