'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _schemaMapperSerializer = require('schema-mapper-serializer');

var _schemaMapperSerializer2 = _interopRequireDefault(_schemaMapperSerializer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var knex = require('knex')({ dialect: 'postgres' });
var st = require('knex-postgis')(knex);

/**
 * PostgresqlSerializer
 *
 * @class PostgresqlSerializer
 * @extends {Serializer}
 */

var PostgresqlSerializer = function (_Serializer) {
  _inherits(PostgresqlSerializer, _Serializer);

  function PostgresqlSerializer() {
    _classCallCheck(this, PostgresqlSerializer);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(PostgresqlSerializer).apply(this, arguments));
  }

  _createClass(PostgresqlSerializer, [{
    key: 'serializePoint',

    /**
     * Serialize a point.
     *
     * @protected
     * @param  {String} value
     * @param  {Column} column
     */
    value: function serializePoint(value) {
      return this.serializeGeoJSON(value);
    }

    /**
     * Serialize a point array.
     *
     * @protected
     * @param  {String} value
     * @param  {Column} column
     */

  }, {
    key: 'serializePointArray',
    value: function serializePointArray(value) {
      return this.serializeGeoJSON(value);
    }

    /**
     * Serialize a linestring.
     *
     * @protected
     * @param  {String} value
     * @param  {Column} column
     */

  }, {
    key: 'serializeLinestring',
    value: function serializeLinestring(value) {
      return this.serializeGeoJSON(value);
    }

    /**
     * Serialize a linestring array.
     *
     * @protected
     * @param  {String} value
     * @param  {Column} column
     */

  }, {
    key: 'serializeLinestringArray',
    value: function serializeLinestringArray(value) {
      return this.serializeGeoJSON(value);
    }

    /**
     * Serialize a polygon.
     *
     * @protected
     * @param  {String} value
     * @param  {Column} column
     */

  }, {
    key: 'serializePolygon',
    value: function serializePolygon(value) {
      return this.serializeGeoJSON(value);
    }

    /**
     * Serialize a polygon array.
     *
     * @protected
     * @param  {String} value
     * @param  {Column} column
     */

  }, {
    key: 'serializePolygonArray',
    value: function serializePolygonArray(value) {
      return this.serializeGeoJSON(value);
    }

    /**
     * Serialize to geojson.
     *
     * @protected
     * @param  {String} value
     * @param  {Column} column
     */

  }, {
    key: 'serializeGeoJSON',
    value: function serializeGeoJSON(value) {
      if (!value.crs) {
        value.crs = {
          type: 'name',
          properties: { name: 'EPSG:4326' }
        };
      }

      return st.geomFromGeoJSON(value);
    }
  }]);

  return PostgresqlSerializer;
}(_schemaMapperSerializer2.default);

exports.default = PostgresqlSerializer;